// ignore_for_file: avoid_print

import 'package:file_picker/file_picker.dart';
import 'package:flutter/material.dart';
import 'package:image_picker/image_picker.dart';
import '../model/story.dart';
import '../widget/camer_picker.dart';
import '../widget/my_story.dart';

class StoryListPage extends StatelessWidget {
  const StoryListPage({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) => Scaffold(
    body: InkWell(
        onTap: () => showDialogBox(context),
        child: const Text('Click Here'))
  );

  void openFile(BuildContext context, List<PlatformFile> files){
    List<Story> stories = [];
    for (final files in files){
      MediaType mediaType;
      if(files.extension?.contains('jpg') == true || files.extension?.contains('png') == true){
        mediaType = MediaType.image;
      }else {
        mediaType = MediaType.video;
      }
      stories.add(Story(
        mediaType: mediaType,
        url: files.path.toString(),
      ));
    }
    Navigator.of(context).push(
        MaterialPageRoute(builder: (context) => MyStoryScreen(stories: stories)
        )
    );
  }

  void showDialogBox(BuildContext context) {
    showDialog(
      context: context,
      builder: (_) {
        return SimpleDialog(
          title: const Text('Choose an Option'),
          children: [
            SimpleDialogOption(
              child: const Text('Camera'),
              onPressed: () async {
                Navigator.pop(context);
                await Navigator.of(context)
                    .push(MaterialPageRoute(builder: (context) => const CameraPage()));
              },
            ),
            SimpleDialogOption(
              child: const Text('Gallery'),
              onPressed: () async {
                Navigator.pop(context);
                final result = await FilePicker.platform.pickFiles(
                    allowMultiple: true,
                    type: FileType.custom,
                    allowedExtensions: ['jpg', 'png', 'mp4']
                );
                if(result == null) return;
                // ignore: use_build_context_synchronously
                openFile(context,result.files);
              },
            )
          ],
        );
      },
    );
  }

  Future<List<PlatformFile>?> pickFiles(BuildContext context, List<String>? extensionList) async {
    final result = await FilePicker.platform.pickFiles(
        allowMultiple: true,
        type: FileType.custom,
        allowedExtensions: extensionList
    );

    if(result == null) return null;
    // ignore: use_build_context_synchronously
    //openFile(context,result.files);
    return result.files;
  }

  String? openCamera(BuildContext context) {
    final ImagePicker picker = ImagePicker();
    String? path;
    showDialog(
      context: context,
      builder: (_) {
        return SimpleDialog(
          title: const Text('Choose an Option'),
          children: [
            SimpleDialogOption(
              child: const Text('Image'),
              onPressed: () async {
                Navigator.pop(context);
                final XFile? photo = await picker.pickImage(source: ImageSource.camera);
                path = photo?.path.toString();
                print("path - $path");
              },
            ),
            SimpleDialogOption(
              child: const Text('Video'),
              onPressed: () async {
                Navigator.pop(context);
                final XFile? photo = await picker.pickVideo(source: ImageSource.camera);
                path = photo?.path.toString();
                print('path $path');
              },
            )
          ],
        );
      },
    );
    return path;
  }

}